unit TestPublicX12Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, WorkCom_Type, ComCtrls, Grids, Spin;
//   publicX12.dll
  procedure  InitSlot(Conf :pTSlot);stdcall;
  function GetID():BYTE;stdcall;
  function GetModuleCount(ID : pSLibID):BYTE;stdcall;
  function GetModuleRecord(ID : pSLibID;Number :BYTE):BYTE;stdcall;
  function GetCurrentData(ID : pSLibID):BYTE;stdcall;
  function GetAccumulatedData(ID : pSLibID):BYTE;stdcall;
  function GetArhiveCount(ID : pSLibID):BYTE;stdcall;
  function GetArhiveTime_Hour(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveT_Hour(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveU_Hour(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveM_Hour(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveE_Hour(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveTime_Day(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveT_Day(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveU_Day(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveM_Day(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetArhiveE_Day(ID : pSLibID;Number :BYTE;NBBegin: LongWord):BYTE;stdcall;
  function GetEditHModule(ID : pSLibID;Number :BYTE):BYTE;stdcall;
  function GetEditDataModule(ID : pSLibID;Number :BYTE):BYTE;stdcall;
  function GetErrorHDev(ID : pSLibID):BYTE;stdcall;
  function GetErrorHModule(ID : pSLibID;NumberModule:BYTE ):BYTE;stdcall;
  function GetErrorDataDev(ID : pSLibID;ErrorType :BYTE ):BYTE;stdcall;
  function GetErrorDataModule(ID : pSLibID;NumberModule :BYTE;ErrorType:BYTE ):BYTE;stdcall;
//   publicX12.dll
type
  TFormTest = class(TForm)
    Panel1: TPanel;
    CB_COMPORT: TComboBox;
    Ed_Speed: TEdit;
    Ed_NetAddress: TEdit;
    But_Connect: TButton;
    Panel2: TPanel;
    LStatus: TLabel;
    Button1: TButton;
    Button2: TButton;
    EdTimeout: TEdit;
    Button3: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel3: TPanel;
    Button4: TButton;
    StringGrid1: TStringGrid;
    TabSheet2: TTabSheet;
    Panel4: TPanel;
    Button5: TButton;
    Memo1: TMemo;
    Button6: TButton;
    TabSheet3: TTabSheet;
    Panel5: TPanel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Memo2: TMemo;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    TabSheet4: TTabSheet;
    Panel6: TPanel;
    Button18: TButton;
    Button19: TButton;
    Memo3: TMemo;
    TabSheet5: TTabSheet;
    Panel7: TPanel;
    Button20: TButton;
    Button21: TButton;
    Memo4: TMemo;
    Button22: TButton;
    Button23: TButton;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure But_ConnectClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
  private
    ASDate:String;
    ASEvent:String;
    hCom : THandle;
    ModuleConfig:SLibModuleRecord;
    CurrentData : SLibCurrentData;
    AccumulatedData : SLibAccumulatedData;
    ArhiveCount : SLibArhiveCount;
    procedure InitPublicX12();
    function SecondsToDateTime(Seconds: Longword): TDateTime;
    procedure ConvertEdit(EdRec : pSLibEditRecord);
    procedure ConvertError(pErrorDataDev : pSLibErrorRecord;Module:Boolean);
  public
    Config : TSlot;
    IDDev : SLibID;
    Modulecount :Byte;
    ArhName : String;
//    
    procedure Timeout();
    procedure X12RetID(ID : pSLibID);
    procedure X12ModuleCount(Count :BYTE);
    procedure X12RetModuleRecord(pModuleRec : pSLibModuleRecord);
    procedure X12RetCurrentData(pCurrentData : pSLibCurrentData);
    procedure X12RetAccumulatedData(pAccumulatedData : pSLibAccumulatedData);
    procedure X12RetArhives(pArhiveCount : pSLibArhiveCount);
    procedure X12RetTime_Hour(pArhive : pLongword ;Count : WORD);
    procedure X12RetT_Hour(pArhive : pLongint ;Count : WORD);
    procedure X12RetU_Hour(pArhive : pInt64 ;Count : WORD);
    procedure X12RetEdit_HModule(pEditHModule : pWORD);
    procedure X12RetEdit_DataModule(pEditRecord : pSLibEditRecord ;Count : WORD);
    procedure X12RetError_HDev(pErrorHDev : pWORD ;Count : WORD);
    procedure X12RetError_HModule(pErrorHModule : pWORD ;Count : WORD);
    procedure X12RetError_DataDev(pErrorDataDev : pSLibErrorRecord  ;Count : WORD);
    procedure X12RetError_DataModule(pErrorDataDev : pSLibErrorRecord;Count : WORD);
//    
  end;

var
  FormTest: TFormTest;

implementation

{$R *.dfm}
//   publicX12.dll
procedure  InitSlot; external 'publicX12';
function GetID; external 'publicX12';
function GetModuleCount; external 'publicX12';
function GetModuleRecord; external 'publicX12';
function GetCurrentData; external 'publicX12';
function GetAccumulatedData; external 'publicX12';
function GetArhiveCount; external 'publicX12';
function GetArhiveTime_Hour; external 'publicX12';
function GetArhiveT_Hour; external 'publicX12';
function GetArhiveU_Hour; external 'publicX12';
function GetArhiveM_Hour; external 'publicX12';
function GetArhiveE_Hour; external 'publicX12';
function GetArhiveTime_Day; external 'publicX12';
function GetArhiveT_Day; external 'publicX12';
function GetArhiveU_Day; external 'publicX12';
function GetArhiveM_Day; external 'publicX12';
function GetArhiveE_Day; external 'publicX12';
function GetEditHModule; external 'publicX12';
function GetEditDataModule; external 'publicX12';
function GetErrorHDev; external 'publicX12';
function GetErrorHModule; external 'publicX12';
function GetErrorDataDev; external 'publicX12';
function GetErrorDataModule; external 'publicX12';

//   publicX12.dll
//************************************************************
//    ,  
procedure TimeoutCallBack();stdcall;
begin
  FormTest.Timeout();
end;
procedure X12RetIDCallBack(ID :pSLibID);stdcall;
begin
  FormTest.X12RetID(ID);
end;
procedure X12ModuleCountCallBack(Count :BYTE);stdcall;
begin
  FormTest.X12ModuleCount(Count);
end;
procedure X12RetModuleRecordCallBack(pModuleRec : pSLibModuleRecord); stdcall;
begin
  FormTest.X12RetModuleRecord(pModuleRec);
end;
procedure X12RetCurrentDataCallBack(pCurrentData : pSLibCurrentData); stdcall;
begin
  FormTest.X12RetCurrentData(pCurrentData);
end;
procedure X12RetAccumulatedDataCallBack(pAccumulatedData : pSLibAccumulatedData); stdcall;
begin
  FormTest.X12RetAccumulatedData(pAccumulatedData);
end;
procedure X12RetArhivesCallBack(pArhiveCount : pSLibArhiveCount); stdcall;
begin
  FormTest.X12RetArhives(pArhiveCount);
end;
procedure X12RetTime_HourCallBack(pArhive : pLongword ;Count : WORD); stdcall;
begin
  FormTest.X12RetTime_Hour(pArhive,Count);
end;
procedure X12RetT_HourCallBack(pArhive : pLongint ;Count : WORD); stdcall;
begin
  FormTest.X12RetT_Hour(pArhive,Count);
end;
procedure X12RetU_HourCallBack(pArhive : pInt64 ;Count : WORD); stdcall;
begin
  FormTest.X12RetU_Hour(pArhive,Count);
end;
procedure X12RetEdit_HModuleCallBack(pEditHModule : pWORD); stdcall;
begin
  FormTest.X12RetEdit_HModule(pEditHModule);
end;
procedure X12RetEdit_DataModuleCallBack(pEditRecord : pSLibEditRecord ;Count : WORD); stdcall;
begin
  FormTest.X12RetEdit_DataModule(pEditRecord,Count);
end;
procedure X12RetError_HDevCallBack(pErrorHDev : pWORD ;Count : WORD); stdcall;
begin
  FormTest.X12RetError_HDev(pErrorHDev,Count);
end;
procedure X12RetError_HModuleCallBack(pErrorHModule : pWORD ;Count : WORD); stdcall;
begin
  FormTest.X12RetError_HModule(pErrorHModule,Count);
end;
procedure X12RetError_DataDevCallBack(pErrorDataDev : pSLibErrorRecord  ;Count : WORD); stdcall;
begin
  FormTest.X12RetError_DataDev(pErrorDataDev,Count);
end;
procedure X12RetError_DataModuleCallBack(pErrorDataDev : pSLibErrorRecord;Count : WORD); stdcall;
begin
  FormTest.X12RetError_DataModule(pErrorDataDev,Count);
end;
//    ,  
//************************************************************
//    
procedure TFormTest.Timeout();
Begin
  LStatus.Caption:='  .'
End;
procedure TFormTest.X12RetID(ID :pSLibID);
begin
  IDDev:=ID^;
  LStatus.Caption:=' ,   '+IntToStr(IDDev.Serial);
end;
procedure TFormTest.X12ModuleCount(Count :BYTE);
begin
  ModuleCount:=Count;
  LStatus.Caption:=' '+IntToStr(IDDev.Serial)+ '  '+ IntToStr(ModuleCount)+' .';
end;
procedure TFormTest.X12RetModuleRecord(pModuleRec : pSLibModuleRecord);
begin
  ModuleConfig:=pModuleRec^;
  LStatus.Caption:=' '+IntToStr(IDDev.Serial)+ '  ';
  StringGrid1.Cells[0,0]:='';
  StringGrid1.Cells[1,0]:='';
  StringGrid1.Cells[0,1]:='ModuleType';
  StringGrid1.Cells[1,1]:=IntToStr(ModuleConfig.ModuleType);
  StringGrid1.Cells[0,2]:='Flow[0]';
  StringGrid1.Cells[1,2]:=IntToStr(ModuleConfig.Flow[0]);
  StringGrid1.Cells[0,3]:='Flow[1]';
  StringGrid1.Cells[1,3]:=IntToStr(ModuleConfig.Flow[1]);
  StringGrid1.Cells[0,4]:='Flow[2]';
  StringGrid1.Cells[1,4]:=IntToStr(ModuleConfig.Flow[2]);
  StringGrid1.Cells[0,5]:='Term[0]';
  StringGrid1.Cells[1,5]:=IntToStr(ModuleConfig.Term[0]);
  StringGrid1.Cells[0,6]:='Term[1]';
  StringGrid1.Cells[1,6]:=IntToStr(ModuleConfig.Term[1]);
  StringGrid1.Cells[0,7]:='Term[2]';
  StringGrid1.Cells[1,7]:=IntToStr(ModuleConfig.Term[2]);
  StringGrid1.Cells[0,8]:='TermConst[0]';
  StringGrid1.Cells[1,8]:=FloatToStr(ModuleConfig.TermConst[0]);
  StringGrid1.Cells[0,9]:='TermConst[1]';
  StringGrid1.Cells[1,9]:=FloatToStr(ModuleConfig.TermConst[1]);
  StringGrid1.Cells[0,10]:='TermConst[2]';
  StringGrid1.Cells[1,10]:=FloatToStr(ModuleConfig.TermConst[2]);
  StringGrid1.Cells[0,11]:='PressConst[0]';
  StringGrid1.Cells[1,11]:=FloatToStr(ModuleConfig.PressConst[0]);
  StringGrid1.Cells[0,12]:='PressConst[1]';
  StringGrid1.Cells[1,12]:=FloatToStr(ModuleConfig.PressConst[1]);
  StringGrid1.Cells[0,13]:='PressConst[2]';
  StringGrid1.Cells[1,13]:=FloatToStr(ModuleConfig.PressConst[2]);
end;

procedure TFormTest.X12RetCurrentData(pCurrentData : pSLibCurrentData);
var
  S:String;
  i:byte;
begin
  CurrentData:=pCurrentData^;
  LStatus.Caption:=' '+IntToStr(IDDev.Serial)+ '  ';
  Memo1.Lines.Clear;
  for i:=0 to 5 do
  begin
    S:= 'Term['+IntToStr(i)+']='+ FloatToStr(CurrentData.Term[i]);
    Memo1.Lines.Add(S);
    S:= 'QV['+IntToStr(i)+']='+ FloatToStr(CurrentData.QV[i]);
    Memo1.Lines.Add(S);
    S:= 'QM['+IntToStr(i)+']='+ FloatToStr(CurrentData.QM[i]);
    Memo1.Lines.Add(S);
    S:= 'EV['+IntToStr(i)+']='+ FloatToStr(CurrentData.EV[i]);
    Memo1.Lines.Add(S);
  end;
end;

procedure TFormTest.X12RetAccumulatedData(pAccumulatedData : pSLibAccumulatedData);
var
  S:String;
  i:byte;
  d:double;
begin
  AccumulatedData:=pAccumulatedData^;
  LStatus.Caption:=' '+IntToStr(IDDev.Serial)+ '  ';
  Memo1.Lines.Clear;
  for i:=0 to 5 do
  begin
    S:= 'StopTime['+IntToStr(i)+']='+ IntToStr(AccumulatedData.StopTime[i]);
    Memo1.Lines.Add(S);
    d:=AccumulatedData.E[i];
    d:=d/1000000;
    S:= 'EV['+IntToStr(i)+']='+ FloatToStr(d);
    Memo1.Lines.Add(S);
    d:=AccumulatedData.UV[i];
    d:=d/1000000;
    S:= 'UV['+IntToStr(i)+']='+ FloatToStr(d);
    Memo1.Lines.Add(S);
    d:=AccumulatedData.UM[i];
    d:=d/1000000;
    S:= 'UM['+IntToStr(i)+']='+ FloatToStr(d);
    Memo1.Lines.Add(S);
  end;
end;

procedure TFormTest.X12RetArhives(pArhiveCount : pSLibArhiveCount);
begin
  ArhiveCount:=pArhiveCount^;
  LStatus.Caption:='  '+IntToStr(IDDev.Serial)+ ' '+
    DateTimeToStr(SecondsToDateTime(ArhiveCount.BeginArhive));
end;

procedure TFormTest.X12RetTime_Hour(pArhive : pLongword ;Count : WORD);
var
 i:integer;
 S:String;
begin
  Memo2.Lines.Clear;
  for i:=1 to Count do
  begin
    S:=ArhName+' '+DateTimeToStr(SecondsToDateTime(pArhive^));
    Memo2.Lines.Add(S);
    Inc(pArhive);
  end;
end;

procedure TFormTest.X12RetT_Hour(pArhive : pLongint ;Count : WORD);
var
 i:integer;
 d:double;
 S:String;
begin
  Memo2.Lines.Clear;
  for i:=1 to Count do
  begin
    d:=pArhive^;
    d:=d/100;
    S:=ArhName+' '+FloatToStr(d);
    Memo2.Lines.Add(S);
    Inc(pArhive);
  end;
end;

procedure TFormTest.X12RetU_Hour(pArhive : pInt64 ;Count : WORD);
var
 i:integer;
 d:double;
 S:String;
begin
  Memo2.Lines.Clear;
  for i:=1 to Count do
  begin
    d:=pArhive^;
    d:=d/1000000;
    S:=ArhName+' '+FloatToStr(d);
    Memo2.Lines.Add(S);
    Inc(pArhive);
  end;
end;

procedure TFormTest.X12RetEdit_HModule(pEditHModule : pWORD);
begin
  LStatus.Caption:='  : '+IntToStr(pEditHModule^);
end;

procedure TFormTest.X12RetEdit_DataModule(pEditRecord : pSLibEditRecord ;Count : WORD);
var
 i:integer;
begin
  Memo3.Lines.Clear;
  for i:=0 to Count -1 do
  begin
    ConvertEdit(pEditRecord);
    Memo3.Lines.Add(ASDate);
    Memo3.Lines.Add(ASEvent);
    Inc(pEditRecord);
  end;
end;

procedure TFormTest.X12RetError_HDev(pErrorHDev : pWORD ;Count : WORD);
var
  i:Integer;
  S:String;
begin
  Memo4.Lines.Clear;
  for i:=0 to Count -1 do
  begin
    S:='    '+IntToStr(i)+' ='+IntToStr(pErrorHDev^);
    Inc(pErrorHDev);
    Memo4.Lines.Add(S);
  end;
end;

procedure TFormTest.X12RetError_HModule(pErrorHModule : pWORD ;Count : WORD);
var
  i:Integer;
  S:String;
begin
  Memo4.Lines.Clear;
  for i:=0 to Count -1 do
  begin
    S:='    '+IntToStr(i)+' ='+IntToStr(pErrorHModule^);
    Inc(pErrorHModule);
    Memo4.Lines.Add(S);
  end;
end;
procedure TFormTest.X12RetError_DataDev(pErrorDataDev : pSLibErrorRecord  ;Count : WORD);
var
  i:Integer;
begin
  Memo4.Lines.Clear;
  for i:=0 to Count -1 do
  begin
    ConvertError(pErrorDataDev,false);
    Memo4.Lines.Add(ASDate);
    Memo4.Lines.Add(ASEvent);
    Inc(pErrorDataDev);
  end;
end;

procedure TFormTest.X12RetError_DataModule(pErrorDataDev : pSLibErrorRecord;Count : WORD);
var
  i:Integer;
begin
  Memo4.Lines.Clear;
  for i:=0 to Count -1 do
  begin
    ConvertError(pErrorDataDev,true);
    Memo4.Lines.Add(ASDate);
    Memo4.Lines.Add(ASEvent);
    Inc(pErrorDataDev);
  end;
end;

//    

procedure TFormTest.Button1Click(Sender: TObject);
begin
  hCom:=OpenCOMPort(CB_COMPORT.Text,StrToInt(Ed_Speed.Text));
  if hCom<>Null then
    LStatus.Caption:=' '
  else
    LStatus.Caption:='   ';
end;

function TFormTest.SecondsToDateTime(Seconds: Longword): TDateTime;
begin
  Result := EncodeDate(2000, 1, 1) + Seconds / (24 * 3600);
end;

procedure TFormTest.InitPublicX12();
begin
  Config.hCom:=hCom;
  Config.Address:=StrToInt(Ed_NetAddress.Text);
  Config.WorkType :=0;
  Config.TimeOut:=StrToInt(EdTimeout.Text);
  Config.pTimeOut:=@TimeoutCallBack;
  Config.pRetID:=@X12RetIDCallBack;
  Config.pRetModuleCount:=@X12ModuleCountCallBack;
  Config.pRetModuleRecord:=@X12RetModuleRecordCallBack;
  Config.pRetCurrentData:=@X12RetCurrentDataCallBack;
  Config.pRetAccumulatedData:=@X12RetAccumulatedDataCallBack;
  Config.pRetArhiveCount:=@X12RetArhivesCallBack;
  Config.pRetTime_Hour:=@X12RetTime_HourCallBack;
  Config.pRetT_Hour:=@X12RetT_HourCallBack;
  Config.pRetU_Hour:=@X12RetU_HourCallBack;
  Config.pRetM_Hour:=@X12RetU_HourCallBack;
  Config.pRetE_Hour:=@X12RetU_HourCallBack;
  Config.pRetTime_Day:=@X12RetTime_HourCallBack;
  Config.pRetT_Day:=@X12RetT_HourCallBack;
  Config.pRetU_Day:=@X12RetU_HourCallBack;
  Config.pRetM_Day:=@X12RetU_HourCallBack;
  Config.pRetE_Day:=@X12RetU_HourCallBack;
  Config.pRetError_HDev:=@X12RetError_HDevCallBack;
  Config.pRetError_HModule:=@X12RetError_HModuleCallBack;
  Config.pRetError_DataDev:=@X12RetError_DataDevCallBack;
  Config.pRetError_DataModule:=@X12RetError_DataModuleCallBack;
  Config.pRetEdit_HModule:=X12RetEdit_HModuleCallBack;
  Config.pRetEdit_DataModule:=X12RetEdit_DataModuleCallBack;
end;

procedure TFormTest.Button2Click(Sender: TObject);
begin
  if CloseCOMPort(hCom) then
    LStatus.Caption:=' '
  else
    LStatus.Caption:='   ';
end;

procedure TFormTest.But_ConnectClick(Sender: TObject);
begin
  LStatus.Caption:='OK';
  InitPublicX12;
  InitSlot(@Config);
  GetID();
end;

procedure TFormTest.Button3Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  InitPublicX12;
  InitSlot(@Config);
  GetID();
  GetModuleCount(@IDDev);
end;

procedure TFormTest.Button4Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetModuleRecord(@IDDev,1);
end;

procedure TFormTest.Button5Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetCurrentData(@IDDev);
end;

procedure TFormTest.Button6Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetAccumulatedData(@IDDev);
end;

procedure TFormTest.Button9Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetArhiveCount(@IDDev);
end;

procedure TFormTest.Button7Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  ArhName:='/  ';
  GetArhiveTime_Hour(@IDDev,1,0);
end;

procedure TFormTest.Button8Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  ArhName:=' 1  ';
  GetArhiveT_Hour(@IDDev,1,0);
end;

procedure TFormTest.Button10Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveU_Hour(@IDDev,1,0);
end;

procedure TFormTest.Button11Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveM_Hour(@IDDev,1,0);
end;

procedure TFormTest.Button12Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveE_Hour(@IDDev,1,0);
end;

procedure TFormTest.Button13Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  ArhName:='/  ';
  GetArhiveTime_Day(@IDDev,1,0);
end;

procedure TFormTest.Button14Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  ArhName:=' 1  ';
  GetArhiveT_Day(@IDDev,1,0);
end;

procedure TFormTest.Button15Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveU_Day(@IDDev,1,0);
end;

procedure TFormTest.Button16Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveM_Day(@IDDev,1,0);
end;

procedure TFormTest.Button17Click(Sender: TObject);
begin
  ArhName:=' 1  ';
  LStatus.Caption:='OK';
  GetArhiveE_Day(@IDDev,1,0);
end;


procedure TFormTest.ConvertEdit(EdRec : pSLibEditRecord);
var
  ErrErrorEvent:Byte;
  ErrDeviceNomer:Byte;
  ErrDate:LongWord;
  OldData : Single;
  NewData : Single;
  OldDataINT:LongWord absolute OldData;
  NewDataINT:LongWord absolute NewData;
begin
  OldDataINT:=EdRec^.LastData;
  NewDataINT:=EdRec^.NewData;
  ErrErrorEvent:=EdRec^.ErrorEvent;
  ErrDeviceNomer:=EdRec^.DeviceNomer;
  ErrDate:=EdRec^.Date;
  ASDate:=DateTimeToStr(SecondsToDateTime(ErrDate));
  ASEvent:='';
  if(ErrErrorEvent=$80)then
  begin
    ASEvent:='  ';
    if(ErrDeviceNomer=0) then
      ASEvent:=ASEvent+'/A';
    if(ErrDeviceNomer=1) then
      ASEvent:=ASEvent+'/B ';
    if(ErrDeviceNomer=2) then
      ASEvent:=ASEvent+'/C ';
    ASEvent:=ASEvent+' c ';
    ASEvent:=ASEvent+FloatToStrF(OldData,ffFixed,10,2);
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+FloatToStrF(NewData,ffFixed,10,2);
    ASEvent:=ASEvent+'  ';
    exit;
  end;
  if(ErrErrorEvent=$81)then
  begin
    if(ErrDeviceNomer=0) then
      ASEvent:=ASEvent+'P/A';
    if(ErrDeviceNomer=1) then
      ASEvent:=ASEvent+'P/B ';
    if(ErrDeviceNomer=2) then
      ASEvent:=ASEvent+'P/C ';
    ASEvent:=ASEvent+' c ';
    ASEvent:=ASEvent+FloatToStrF(OldData,ffFixed,10,2);
    ASEvent:=ASEvent+' MPa ';
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+FloatToStrF(NewData,ffFixed,10,2);
    ASEvent:=ASEvent+' MPa ';
    exit;
  end;
  if(ErrErrorEvent=$83)then
  begin
    ASEvent:=' ' ;
    ASEvent:=ASEvent+' c ';
    ASEvent:=ASEvent+DateTimeToStr(SecondsToDateTime(OldDataINT));
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+DateTimeToStr(SecondsToDateTime(NewDataINT));
  end;
  if(ErrErrorEvent=$90) then
  begin
    if(ErrDeviceNomer=0) then
      ASEvent:=ASEvent+'KFS/A';
    if(ErrDeviceNomer=1) then
      ASEvent:=ASEvent+'KFS/B ';
    if(ErrDeviceNomer=2) then
      ASEvent:=ASEvent+'KFS/C ';
    ASEvent:=ASEvent+' c ';
    ASEvent:=ASEvent+FloatToStrF(OldData,ffFixed,10,2);
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+FloatToStrF(NewData,ffFixed,10,2);
  end;
  if(ErrErrorEvent=$91) then
  begin
    if(ErrDeviceNomer=0) then
      ASEvent:=ASEvent+'KFS/A';
    if(ErrDeviceNomer=1) then
      ASEvent:=ASEvent+'KFS/B ';
    if(ErrDeviceNomer=2) then
      ASEvent:=ASEvent+'KFS/C ';
    ASEvent:=ASEvent+' c ';
    ASEvent:=ASEvent+FloatToStrF(OldData,ffFixed,10,3);
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+'  ';
    ASEvent:=ASEvent+FloatToStrF(NewData,ffFixed,10,3);
    ASEvent:=ASEvent+'  ';
  end
end;

procedure TFormTest.Button18Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetEditHModule(@IDDev,1);
end;

procedure TFormTest.Button19Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetEditDataModule(@IDDev,1);
end;

procedure TFormTest.Button22Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetErrorHDev(@IDDev);
end;

procedure TFormTest.Button20Click(Sender: TObject);
begin
  LStatus.Caption:='OK';
  GetErrorHModule(@IDDev,1);
end;

procedure TFormTest.Button23Click(Sender: TObject);
var
  d:Byte;
begin
  LStatus.Caption:='OK';
  d:=SpinEdit1.Value;
  GetErrorDataDev(@IDDev,d);
end;

procedure TFormTest.Button21Click(Sender: TObject);
var
  d:Byte;
begin
  LStatus.Caption:='OK';
  d:=SpinEdit2.Value;
  GetErrorDataModule(@IDDev,1,d);
end;

procedure TFormTest.ConvertError(pErrorDataDev : pSLibErrorRecord;Module:Boolean);
var
  ErrErrorEvent:Byte;
  ErrParametr:Byte;
  ErrDate:LongWord;
begin
  ASDate:='';
  ASEvent:='';
  if(Module=true) then
  begin
    ErrErrorEvent:=pErrorDataDev^.ErrorEvent;
    ErrParametr:=pErrorDataDev^.Parametr;
    ErrDate:=pErrorDataDev^.Date;
  end
  else
  begin
    ErrErrorEvent:=pErrorDataDev^.ErrorEvent;
    ErrParametr:=pErrorDataDev^.Parametr;
    ErrDate:=pErrorDataDev^.Date;
  end;
  ASDate:=DateTimeToStr(SecondsToDateTime(ErrDate));
  if(Module=true)then
  begin
    if(ErrErrorEvent=10) then
    begin
      if(ErrParametr=0) then
        ASEvent:=' '
      else if(ErrParametr=1) then
        ASEvent:='  '
      else if(ErrParametr=2) then
        ASEvent:=' < 0'
      else if(ErrParametr=3) then
        ASEvent:='/A<T/B'
      else if(ErrParametr=10) then
        ASEvent:='  '
      else if(ErrParametr=11) then
        ASEvent:='  e'
      else if(ErrParametr=12) then
        ASEvent:='  > 0'
      else if(ErrParametr=13) then
        ASEvent:='T/A>T/B'
      else
        ASEvent:='  ()';
    end;
    if(ErrErrorEvent=11) then
    begin
      ASEvent:='  ';
    end;
    if(ErrErrorEvent=12) then
    begin
      if(ErrParametr=0) then
        ASEvent:='  '
      else if(ErrParametr=1) then
        ASEvent:='  '
      else if(ErrParametr=11) then
        ASEvent:='  t'
      else if(ErrParametr=2) then
        ASEvent:='  '
      else if(ErrParametr=10) then
        ASEvent:='  '
      else
        ASEvent:='  ()';
    end;
  end
  else
  begin
    if(ErrErrorEvent=0) then
      ASEvent:=' ';
    if(ErrErrorEvent=1) then
      ASEvent:=' ';
    if(ErrErrorEvent=2) then
    begin
      if(ErrParametr=0) then
        ASEvent:=' ';
      if(ErrParametr=1) then
        ASEvent:='   ';
    end;
    if(ErrErrorEvent=3) then
      begin
      if(ErrParametr=0) then
        ASEvent:='   ""';
      if(ErrParametr=1) then
        ASEvent:='   ""';
      end;
    if(ErrErrorEvent=4) then
      begin
      if(ErrParametr=0) then
        ASEvent:='   ""';
      if(ErrParametr=1) then
        ASEvent:='   ""';
      end;
      if(ErrErrorEvent=5) then
      begin
        if(ErrParametr=0) then
          ASEvent:='   ""';
        if(ErrParametr=1) then
          ASEvent:='   ""';
      end;
    end
end;

end.
